/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;


import android.app.SearchManager;
import android.content.ContentProvider;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Intent;
import android.content.UriMatcher;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.R;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;


public class NotesProvider extends ContentProvider {
// 定义UriMatcher，用于匹配Uri
private static final UriMatcher mMatcher;
// 数据库帮助类
private NotesDatabaseHelper mHelper;
// 日志标识
private static final String TAG = "NotesProvider";
// Uri匹配的常量值
private static final int URI_NOTE = 1;
private static final int URI_NOTE_ITEM = 2;
private static final int URI_DATA = 3;
private static final int URI_DATA_ITEM = 4;
private static final int URI_SEARCH = 5;
private static final int URI_SEARCH_SUGGEST = 6;

static {
    mMatcher = new UriMatcher(UriMatcher.NO_MATCH);
    // 添加Uri匹配规则
    mMatcher.addURI(Notes.AUTHORITY, "note", URI_NOTE);
    mMatcher.addURI(Notes.AUTHORITY, "note/#", URI_NOTE_ITEM);
    mMatcher.addURI(Notes.AUTHORITY, "data", URI_DATA);
    mMatcher.addURI(Notes.AUTHORITY, "data/#", URI_DATA_ITEM);
    mMatcher.addURI(Notes.AUTHORITY, "search", URI_SEARCH);
    mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY, URI_SEARCH_SUGGEST);
    mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY + "/*", URI_SEARCH_SUGGEST);
}

/**
 * 将'\n'字符替换成空格，用于搜索结果标题和内容的显示
 */
private static final String NOTES_SEARCH_PROJECTION = NoteColumns.ID + ","
        + NoteColumns.ID + " AS " + SearchManager.SUGGEST_COLUMN_INTENT_EXTRA_DATA + ","
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_1 + ","
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_2 + ","
        + R.drawable.search_result + " AS " + SearchManager.SUGGEST_COLUMN_ICON_1 + ","
        + "'" + Intent.ACTION_VIEW + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_ACTION + ","
        + "'" + Notes.TextNote.CONTENT_TYPE + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_DATA;

// 搜索语句
private static String NOTES_SNIPPET_SEARCH_QUERY =
        "SELECT " + NOTES_SEARCH_PROJECTION
                + " FROM " + TABLE.NOTE
                + " WHERE " + NoteColumns.SNIPPET + " LIKE ?"
                + " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER
                + " AND " + NoteColumns.TYPE + "=" + Notes.TYPE_NOTE;

@Override
public boolean onCreate() {
    // 获取数据库帮助类实例
    mHelper = NotesDatabaseHelper.getInstance(getContext());
    return true;
}

@Override
public Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs,
                    String sortOrder) {
    Cursor c = null;
    SQLiteDatabase db = mHelper.getReadableDatabase();
    String id = null;
    switch (mMatcher.match(uri)) {
        case URI_NOTE:
            c = db.query(TABLE.NOTE, projection, selection, selectionArgs, null, null,
                    sortOrder);
            break;
        case URI_NOTE_ITEM:
            id = uri.getPathSegments().get(1);
            c = db.query(TABLE.NOTE, projection, NoteColumns.ID + "=" + id
                    + parseSelection(selection), selectionArgs, null, null, sortOrder);
            break;
        case URI_DATA:
            c = db.query(TABLE.DATA, projection, selection, selectionArgs, null, null,
                    sortOrder);
            break;
        case URI_DATA_ITEM:
            id = uri.getPathSegments().get(1);
            c = db.query(TABLE.DATA, projection, DataColumns.ID + "=" + id
                    + parseSelection(selection), selectionArgs, null, null, sortOrder);
            break;
        case URI_SEARCH:
        case URI_SEARCH_SUGGEST:
            if (sortOrder != null || projection != null) {
                throw new IllegalArgumentException(
                        "do not specify sortOrder, selection, selectionArgs, or projection"
                                + "with this query");
            }
            String searchString = null;
            if (mMatcher.match(uri) == URI_SEARCH_SUGGEST) {
                if (uri.getPathSegments().size() > 1) {
                    searchString = uri.getPathSegments().get(1);
                }
            } else {
                searchString = uri.getQueryParameter("pattern");
            }
            if (TextUtils.isEmpty(searchString)) {
                return null;
            }
            try {
                searchString = String.format("%%%s%%", searchString);
                c = db.rawQuery(NOTES_SNIPPET_SEARCH_QUERY,
                        new String[] { searchString });
            } catch (IllegalStateException ex) {
                Log.e(TAG, "got exception: " + ex.toString());
            }
            break;
        default:
            throw new IllegalArgumentException("Unknown URI " + uri);
    }
    if (c != null) {
        // 设置查询结果发生改变时更新的Uri
        c.setNotificationUri(getContext().getContentResolver(), uri);
    }
    return c;
}
}
 @Override
public Uri insert(Uri uri, ContentValues values) {
SQLiteDatabase db = mHelper.getWritableDatabase();//获取写入模式的数据库
long dataId = 0, noteId = 0, insertedId = 0;//初始化三个变量
switch (mMatcher.match(uri)) {//根据Uri匹配相应的操作
case URI_NOTE://如果是Note表
insertedId = noteId = db.insert(TABLE.NOTE, null, values);//插入数据并获取行号
break;
case URI_DATA://如果是Data表
if (values.containsKey(DataColumns.NOTE_ID)) {//判断是否包含note id
noteId = values.getAsLong(DataColumns.NOTE_ID);//获取note id
} else {
Log.d(TAG, "Wrong data format without note id:" + values.toString());//打印错误日志
}
insertedId = dataId = db.insert(TABLE.DATA, null, values);//插入数据并获取行号
break;
default:
throw new IllegalArgumentException("Unknown URI " + uri);//如果Uri不匹配则抛异常
}
// Notify the note uri
if (noteId > 0) {//如果note id不为空
getContext().getContentResolver().notifyChange(//调用notifyChange方法，通知Uri已经被更改
ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId), null);//ContentUris.withAppendedId方法是在后面添加一个id，用来获取Uri
}
// Notify the data uri
if (dataId > 0) {//如果data id不为空
getContext().getContentResolver().notifyChange(//调用notifyChange方法，通知Uri已经被更改
ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId), null);//ContentUris.withAppendedId方法是在后面添加一个id，用来获取Uri
}
return ContentUris.withAppendedId(uri, insertedId);//最终返回更新后的Uri
}

@Override
public int delete(Uri uri, String selection, String[] selectionArgs) {
int count = 0;
String id = null;
SQLiteDatabase db = mHelper.getWritableDatabase();//获取写入模式的数据库
boolean deleteData = false;//初始化deleteData变量
switch (mMatcher.match(uri)) {//根据Uri匹配相应的操作
case URI_NOTE://如果是Note表
selection = "(" + selection + ") AND " + NoteColumns.ID + ">0 ";//删除条件
count = db.delete(TABLE.NOTE, selection, selectionArgs);//删除数据，并获取删除行数
break;
case URI_NOTE_ITEM:
id = uri.getPathSegments().get(1);//获取Uri中的id
/*ID that smaller than 0 is system folder which is not allowed to trash*/
long noteId = Long.valueOf(id);//将id转化为long类型
if (noteId <= 0) {
break;
}
count = db.delete(TABLE.NOTE,
NoteColumns.ID + "=" + id + parseSelection(selection), selectionArgs);//删除数据，并获取删除行数
break;
case URI_DATA://如果是Data表
count = db.delete(TABLE.DATA, selection, selectionArgs);//删除数据，并获取删除行数
deleteData = true;//deleteData为true
break;
case URI_DATA_ITEM:
id = uri.getPathSegments().get(1);//获取Uri中的id
count = db.delete(TABLE.DATA,
DataColumns.ID + "=" + id + parseSelection(selection), selectionArgs);//删除数据，并获取删除行数
deleteData = true;//deleteData为true
break;
default:
throw new IllegalArgumentException("Unknown URI " + uri);//如果Uri不匹配则抛异常
}
if (count > 0) {//如果删除行数大于0
if (deleteData) {//如果是Data表
getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);//调用notifyChange方法，通知Uri已经被更改
}
getContext().getContentResolver().notifyChange(uri, null);//调用notifyChange方法，通知Uri已经被更改
}
return count;//返回删除行数
}

@Override
public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs) {
int count = 0;
String id = null;
SQLiteDatabase db = mHelper.getWritableDatabase();//获取写入模式的数据库
boolean updateData = false;//初始化updateData变量
switch (mMatcher.match(uri)) {//根据Uri匹配相应的操作
case URI_NOTE://如果是Note表
increaseNoteVersion(-1, selection, selectionArgs);//更新版本号
count = db.update(TABLE.NOTE, values, selection, selectionArgs);//更新数据，并获取更新行数
break;
case URI_NOTE_ITEM:
id = uri.getPathSegments().get(1);//获取Uri中的id
increaseNoteVersion(Long.valueOf(id), selection, selectionArgs);//更新版本号
count = db.update(TABLE.NOTE, values, NoteColumns.ID + "=" + id
+ parseSelection(selection), selectionArgs);//更新数据，并获取更新行数
break;
case URI_DATA://如果是Data表
count = db.update(TABLE.DATA, values, selection, selectionArgs);//更新数据，并获取更新行数
updateData = true;//updateData为true
break;
case URI_DATA_ITEM:
id = uri.getPathSegments().get(1);//获取Uri中的id
count = db.update(TABLE.DATA, values, DataColumns.ID + "=" + id
+ parseSelection(selection), selectionArgs);//更新数据，并获取更新行数
updateData = true;//updateData为true
break;
default:
throw new IllegalArgumentException("Unknown URI " + uri);//如果Uri不匹配则抛异常
}
if (count > 0) {//如果更新行数大于0
if (updateData) {//如果是Data表
getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);//调用notifyChange方法，通知Uri已经被更改
}
getContext().getContentResolver().notifyChange(uri, null);//调用notifyChange方法，通知Uri已经被更改
}
return count;//返回更新行数
}

private String parseSelection(String selection) {
return (!TextUtils.isEmpty(selection) ? " AND (" + selection + ')' : "");//解析选择条件
}

private void increaseNoteVersion(long id, String selection, String[] selectionArgs) {
StringBuilder sql = new StringBuilder(120);//创建一个StringBuilder
sql.append("UPDATE ");
sql.append(TABLE.NOTE);//更新Note表
sql.append(" SET ");
sql.append(NoteColumns.VERSION);
sql.append("=" + NoteColumns.VERSION + "+1 ");//版本号加1
if (id > 0 || !TextUtils.isEmpty(selection)) {//如果id大于0或有选择条件
sql.append(" WHERE ");//添加WHERE子句
}
if (id > 0) {//如果id大于0
sql.append(NoteColumns.ID + "=" + String.valueOf(id));//更新对应的id
}
if (!TextUtils.isEmpty(selection)) {//如果选择条件不为空
String selectString = id > 0 ? parseSelection(selection) : selection;
for (String args : selectionArgs) {
selectString = selectString.replaceFirst("\?", args);
}
sql.append(selectString);//解析选择条件并添加进sql中
}
mHelper.getWritableDatabase().execSQL(sql.toString());//执行sql语句
}

@Override
public String getType(Uri uri) {
// TODO Auto-generated method stub
return null;//返回空类型
}

